/*************************************************************************
* Rutoken                                                                *
* Copyright (c) 2003-2017, CJSC Aktiv-Soft. All rights reserved.         *
* Подробная информация:  http://www.rutoken.ru                           *
*************************************************************************/

/*
 * Copyright (c) 2017, CJSC Aktiv-Soft.
 * All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package ru.rutoken.Pkcs11;

/**
 * @author Aktiv Co. <hotline@rutoken.ru>
 */

import com.sun.jna.NativeLong;

import java.util.Arrays;
import java.util.List;

public class CK_GOSTR3410_DERIVE_PARAMS_JRT extends Pkcs11Structure {

    public NativeLong kdf;

    public NativeLong ulPublicDataLen;

    public byte[] pPublicData = new byte[64];

    public NativeLong ulUKMLen;

    public byte[] pUKM = new byte[8];

    public CK_GOSTR3410_DERIVE_PARAMS_JRT() {}

    public CK_GOSTR3410_DERIVE_PARAMS_JRT(NativeLong kdf, NativeLong publicKeyLen, byte[] publicKey, NativeLong ukmLen, byte[] ukm)
    {
        this.kdf = kdf;
        this.ulPublicDataLen = publicKeyLen;
        this.pPublicData = publicKey;
        this.ulUKMLen = ukmLen;
        this.pUKM = ukm;
    }

    protected List<String> getFieldOrder() {
        return Arrays.asList(new String[] {
                "kdf",
                "ulPublicDataLen",
                "pPublicData",
                "ulUKMLen",
                "pUKM"
        });
    }
}